//O[oϐ
float4x4 g_mWorldViewProjection;	//Wϊs
texture  g_Texture;			//eNX`

//eNX`̃TvO@
sampler MeshTextureSampler =
sampler_state
{
	Texture = <g_Texture>;//Ώۂ̃eNX`(O󂯎܂)
	MinFilter = LINEAR; //k̃TvO(LINEAR`⊮)
	MagFilter = LINEAR; //g厞
	MipFilter = NONE;   //~bv}bv

	//eNX`AhbVO[h
	AddressU = Clamp;	//iClanp0`1ȊO̍W̎ɒ[̃sNZЂ̂΂j
	AddressV = Clamp;

};

//_VF[_̏o͏o͒`
struct VS_OUTPUT
{
	float4 Pos : POSITION;
	float4 Diffuse : COLOR0;
	float2 TexUV : TEXCOORD0;
};

//_VF[_iɍWϊj
VS_OUTPUT RenderSceneVS(
	float4 Pos : POSITION,
	float4 aDiffuse : COLOR0,
	float2 vTexCoord0 : TEXCOORD0 )
{
	VS_OUTPUT Out;

	Out.Pos = mul(Pos, g_mWorldViewProjection);
	Out.TexUV = vTexCoord0;
	Out.Diffuse = aDiffuse;

	return Out;
}

//sNZVF[_o͒`
struct PS_OUTPUT
{
    float4 RGB : COLOR0;
};

//sNZVF[_ieNX`Fɒ_Fj
PS_OUTPUT RenderScenePS( VS_OUTPUT In )
{
	PS_OUTPUT Out;

	Out.RGB = tex2D( MeshTextureSampler, In.TexUV ) * In.Diffuse;

	return Out;
}

//sNZVF[_(eNX`Fɒ_FămN)
PS_OUTPUT RenderScenePSMono( VS_OUTPUT In )
{
	PS_OUTPUT Out;

	//eNX`̃sNZFɒ_FF
	float4 color = tex2D( MeshTextureSampler, In.TexUV ) * In.Diffuse;

	//mNɂƂRGB̕SB
	float4 tomono = float4( 0.298912, 0.586611, 0.114478, 0.0 );

	//eNX`̃sNZFɒ_F
	Out.RGB = dot( color, tomono );

	//At@l͌̃eNX`ɖ߂
	Out.RGB.w = color.w;

	return Out;
}

//eNjbNƃpX
//̃eNjbNpX`ăVF[_vO؂ւ邱Ƃł܂B
technique RenderScene
{
	//J[\̏ꍇ
	pass P0
	{
		VertexShader = compile vs_2_0 RenderSceneVS();
		PixelShader = compile ps_2_0 RenderScenePS();
	}
	//mN\̏ꍇ
	pass P1
	{
		VertexShader = compile vs_2_0 RenderSceneVS();
		PixelShader = compile ps_2_0 RenderScenePSMono();
	}
}
