#pragma once
#include <d3d9.h>
#include <d3d9types.h>
#include <d3dx9tex.h>

#pragma warning(disable:4482)

//ʕ\[h
enum LGraphicDisplayMode {
	FullScreen,
	WindowMode,
};

//-------------------------------------------
//	Direct3D@@ Q
//-------------------------------------------
//Direct3D
bool LGraphic_Create( HWND hWnd, LGraphicDisplayMode mode = LGraphicDisplayMode::WindowMode );
//Direct3D
void LGraphic_Release();	

//Direct3DfoCXQƂ
LPDIRECT3DDEVICE9 GetDevice();

void LGraphic_ClearAndBegin();//`OɌĂ
void LGraphic_EndAndPresent();//`ɌĂ

//-------------------------------------------
//	eNX`
//-------------------------------------------
//ǂݍ
LPDIRECT3DTEXTURE9 LGraphic_LoadTexture(LPCWSTR path);
//eNX`Zbg
inline void LGraphic_SetTexture(LPDIRECT3DTEXTURE9 pTexture ) { GetDevice()->SetTexture(0, pTexture ); }

//-------------------------------------------
//	VF[_(HLSL)
//-------------------------------------------
class Shader
{
	LPD3DXEFFECT m_pEffect;
	LPDIRECT3DVERTEXDECLARATION9 m_pVertexDeclaration;

	//VF[_̃O[oϐnh
	D3DXHANDLE	m_WorldViewProjection;	//Wϊs
	D3DXHANDLE	m_Texture;				//eNX`
	
	UINT		m_pass;					//pXCfbNX

public:

	Shader();
	
	//VF[_쐬iVF[_vOt@C̓ǂݍ݁j
	bool Create( LPCWSTR path );
	
	//pXCfbNXZbgiVF[_vȎgݍ킹؂ւj
	void ChangePass( UINT pass );

	//VF[_Kp
	void Begin();
	//VF[_̃O[oϐɒlZbg
	void SetData( D3DXMATRIX* mat, LPDIRECT3DTEXTURE9 texture );
	//VF[_I
	void End();

	//
	void Release();
};